import os
from zc.async.testing import wait_for_result
from zope.interface.verify import verifyClass, verifyObject
from zope.component import getUtility
from waeup.kofa.interfaces import IJobManager
from waeup.kofa.students.reports.level_report import (
    get_students, LevelReport, ILevelReport)
from waeup.kofa.students.tests.test_catalog import CatalogTestSetup
from waeup.kofa.students.tests.test_browser import StudentsFullSetup
from waeup.kofa.browser.tests.test_pdf import samples_dir

from waeup.aaue.students.reports.level_report import CustomLevelReport

from waeup.aaue.testing import FunctionalLayer

class LevelReportTests(CatalogTestSetup):

    layer = FunctionalLayer

    def test_iface(self):
        # ensure we fullfill interface contracts
        obj = LevelReport('fac1', 'dep1', 2010, 100)
        verifyClass(ILevelReport, LevelReport)
        verifyObject(ILevelReport, obj)
        return

    def test_get_students(self):
        # we can get a table with one student
        self.student['studycourse']['100']['Course1'].ca = 0
        result = get_students('fac1', 'dep1', 2010, 100)
        self.assertEqual(result,
            [(u'1234', u'TESTER, Bob', 30, 30, '5.00', 'nil', 0, 30, 30, '5.000', 'Proceed')])
        return

    def test_create_pdf(self):
        self.student['studycourse']['100']['Course1'].ca = 0
        report = CustomLevelReport('fac1', 'dep1', 2010, 100)
        result = report.create_pdf('JOB_ID')
        self.assertTrue(result.startswith('%PDF-'))
        path = os.path.join(samples_dir(), 'level_report.pdf')
        open(path, 'wb').write(result)
        print "Sample level_report.pdf written to %s" % path
        return
